# C++ : переменные

## Переопределяемые переменные { #D }

Переменные, которые можно переопределить из командной строки [`ya make -DVAR`](../../usage/ya_make/index.md#D)

- `CFLAGS`/`CONLYFLAGS`/`CXXFLAGS`/`CUDACUDA_NVCC_FLAGS` -- дополнительные параметры компиляции для C/C++, только C, только C++, .cu

- `LDFLAGS` -- дополнительные параметры линковки.

- `USE_ARCADIA_LIBM[=yes]` -- линковаться статически с libm из репозитория (по умолчанию берётся из системы динамической линковкой).

- `NO_OPTIMIZE[=yes]` -- выключить оптимизации компилятора

- `NO_COMPILER_WARNINGS[=yes]` -- выключить предупреждения компилятора

- `NO_SSE4[=yes]` -- выключить поддержку SSE4 включенную в аркадии по умолчанию

- `NOSSE[=yes]` -- полностью отключить SSE.

  {% note warning %}

  Linux ABI для Intel64 требует наличия SSE2 для операций с плавающей точкой. С отключенным SSE корректно будут работать только программы, где таких операций нет совсем.

  {% endnote %}

- `USE_STL_SYSTEM` -- использовать STL из системы, а не из Аркадии. Может быть нужно для релиза динамических библиотек с C++-интерфейсом. **Работоспособность программ в этом режиме не гарантируется. Тестируйте свой код.**




```
MUSL
SSE*_CFLAGS
...
```
