# Сборка tar-пакетов
Сборка tar-архивов происходит, если не передавать формат пакетирования явно, но можно и указать ключ ```--tar```.

```bash
ya package <pkg.json>
```
или
```bash
ya package <pkg.json> --tar
```

## Ключи для сборки пакетов { #keys }
* `--compression-filter=X` задать фильтр для tar архива, по умолчанию - gzip. Может быть gzip/zstd
* `--compression-level=X` задать уровень сжатия для фильтра. Для gzip может быть 0-9 (по умолчанию: 6), для zstd может быть 0-22 (по умолчанию: 3)
* `--no-compression` создавать архив без сжатия
* `--raw-package` используется вместе с `--tar`, сохраняет пакет без архивирования
* `--raw-package-path=PATH` позволяет переопределить директорию для сохранения пакета без архивирования

{% note tip %}

Для ускорения сборки пакетов, можете попробоавть использовать `--compression-filter=zstd --compression-level=1`. В этом случае будет генерироваться архив в расширением `.tar.zst`

{% endnote %}
