# Введение

**Инструменты разработки** — обобщенное название большого набора сервисов и инструментов, используемых для эффективной разработки, тестирования и выкладки исходного кода в Яндексе.

## Основные разделы документации

### [Начало работы](intro/quick-start-guide.md) { #intro }
В разделе приведена пошаговая инструкция, помогающая быстро установить себе все основные инструменты разработки и загрузить исходные коды из репозитория.

### [Работа с исходным кодом](src/arcadia.md) { #src }
В разделе содержится описание основных инструментов, используемых для работы с исходным кодом: единый репозиторий Аркадия, система контроля версий Arc, веб-интерфейс Arcanum.

### [Правила разработки](rules/intro.md) { #dev }
В разделе приведен список поддерживаемых языков программирования и основные правила написания кода в Яндексе.

### [Сборка исходного кода](build/index.md) { #build }
В разделе содержится информация об общих принципах сборки кода, описании процесса сборки, поддерживаемых платформах и особенностях сборки в разных языках программирования.

### [Тестирование](test/intro.md) { #test }
В разделе рассказывается про особенности тестирования исходного кода.

### [Пакетирование](package.md) { #pkg }
В разделе описано каким образом можно распространять готовые версии программ, какие типы пакетов поддерживаются и как собрать пакет.

## Полезные ссылки { #links }
* [Веб-интерфейс Arcanum](http://a.yandex-team.ru/)
* [Клуб в Этушке](https://clubs.at.yandex-team.ru/arcadia/)
* [Как сообщить о проблеме](intro/support.md)
