# Сигналы

В админке Драйва сигнал представляет собой тег, который может быть присвоен различным сущностям:

- **Машине**. Например, Лаг телематики, Выезд из зоны.
- **Поездке**. Это сигналы, основанные на тегах сессий: Опасная поездка, Превышение скорости.
- **Пользователю**. Например, скоринг превысил заданное значение.

Присвоение тега машине, поездке или пользователю выполняют роботы.

В каждый момент времени система получает поток информации с телематики и установленных в автомобиле камер. Значение какого-либо параметра или историю его изменения принято называть событием. Само по себе событие не является сигналом.

Робот обрабатывает событие в соответствии с логикой сигнала. Если логика сработала, робот формирует соответствующий тег и присваивает его машине, поездке или пользователю. У каждого сигнала своя логика обработки.

{% cut "Примеры логики сигналов" %}

|**Событие:**|**Логика обработки:**| **Тег:**|
|------------|---------------------|---------|
|Объем топлива в баке каждую минуту.|Снижение объема топлива за одну минуту более чем на заданное значение.|Слив топлива.|
|Машина находится на связи и передает данные.|Связи с машиной нет более чем заданный промежуток времени.|Лаг телематики.|

{% endcut %}

Робот появляется в системе в момент, когда в интерфейсе Драйвматики создают новый сигнал. Робот обрабатывает события в соответствии с настройками этого сигнала и присваивает сущности заданный тег.

