# Учет сотрудников в подразделении

Внутри одного отдела или службы сотрудники могут работать на разных зонтиках, контурах или стримах. Руководитель подразделения может посмотреть, у всех ли подчиненных есть цели и загрузка, и при необходимости скорректировать.

Чтобы перейти в учет сотрудников в подразделении:

1. На левой панели нажмите **Поисковый портал** и выберите подразделение из списка.
1. В правом верхнем углу нажмите **Сотрудники**.

Откроется таблица со списком сотрудников, которые работают в выбранном подразделении.


## Просмотреть список сотрудников {#view-list}

В верхней части таблицы отображается название подразделения и количество сотрудников, которые в нем работают.

В строке каждого сотрудника указаны:

* все цели, над которыми работает сотрудник;
* загрузка в каждой цели и общая загрузка в процентах;
* Стафф-подразделение;
* основной зонт.

Вы можете выбирать варианты просмотра списка, используя фильтры в столбцах таблицы:

#### Отфильтровать список по целям и загрузке сотрудников {#filter-goals}

1. Нажмите ![](_assets/ico-filter-okr.png) **Цели и загрузка**.
1. Выберите значение фильтра:
    * **Все** — в таблице отобразятся все сотрудники подразделения.
    * **Без целей** — в таблице отобразятся сотрудники, которые не привязаны к стримам.
    * **Перегруженные** — в таблице отобразятся сотрудники, общая загрузка которых выше 100%.
    * **Недогруженные** — в таблице отобразятся сотрудники, общая загрузка которых ниже 100%.
    

#### Отфильтровать список по основному зонту сотрудника {#filter-umbrella}

1. Нажмите ![](_assets/ico-filter-okr.png) **Основной зонт**.
1. Выберите значение фильтра:
    * **Все** — в таблице отобразятся все сотрудники подразделения.
    * **Не указан основной зонт** — в таблице отобразятся сотрудники, у которых нет основного зонта.

Общее количество сотрудников в верхней части таблицы изменится с учетом выбранного фильтра.


## Изменить цели и загрузку сотрудника {#edit-goals}

1. В строке сотрудника наведите указатель на его цели и загрузку.
1. Нажмите кнопку ![](_assets/ico-edit.png).
1. Выполните действие:
    
    #### Изменить цель {#edit-goal}
    
    1. Чтобы удалить текущую цель, в поле с названием цели нажмите кнопку ![](_assets/ico-del-cross.png).
    1. Начните вводить название цели и выберите из выпадающего списка.
    
    #### Изменить загрузку {#edit-load}
    
    В строке цели укажите новое значение загрузки.
    
    После сохранения изменений общая загрузка сотрудника пересчитается автоматически.
    
    #### Добавить цель {#add-goal}
    
    1. Нажмите **Добавить цель**.
    1. Начните вводить название цели и выберите из выпадающего списка.
    1. Укажите загрузку в процентах.

    #### Удалить цель {#delete-goal}

    В конце строки цели нажмите кнопку ![](_assets/ico-del-cross.png).
    
1. Нажмите **Сохранить**.


## Изменить основной зонт сотрудника {#edit-umbrella}

Основной зонт выбирается руководителем сотрудника для его оценки в процессе ревью. У сотрудника может быть только один основной зонт.

Чтобы изменить или указать основной зонт:

1. В строке сотрудника наведите указатель на его основной зонт. Если зонт не указан, наведите указатель на пустую ячейку в столбце **Основной зонт**.
1. Нажмите кнопку ![](_assets/ico-edit.png).
1. Чтобы удалить указанный зонт, нажмите кнопку ![](_assets/ico-del-cross.png).
1. Начните вводить название цели и выберите из выпадающего списка.
1. Нажмите **Сохранить**.

## Сохранить таблицу {#save-table}

В правом верхнем углу нажмите **Выгрузить людей**.

Таблица сохранится на вашем компьютере в формате XLSX.
