# Управление сотрудниками в табличном представлении целей

Чтобы перейти к [табличному представлению](table-view.md) целей Градиента:

1. На левой панели нажмите кнопку ![](_assets/ico-okr-nav.png) **OKR**. Отобразится список стримов.
1. Наведите указатель на стрим, который вы хотите открыть в табличном представлении, и нажмите кнопку ![](_assets/ico-table-view.png).
Откроется таблица со списком всех зонтиков и контуров выбранного стрима.
    
## Просмотреть запланированное и фактическое количество сотрудников {#view}

Количество сотрудников отображается в столбцах:

* **HC** — количество сотрудников (HeadCount), которое необходимо для выполнения контура или зонтика. Для зонтика указывается суммарное количество сотрудников всех контуров, входящих в этот зонтик.
* **Команда** — фактическое количество сотрудников, которые работают над выполнением зонтика или контура.
    
    В этом столбце отображается:
    * общее количество сотрудников, работающих над целью — в поле **Всего**;
    * количество сотрудников каждой профессии — после общего количества сотрудников;
    * список сотрудников с указанием профессии и загрузки каждого сотрудника.
    
    Количество сотрудников считается с учетом загрузки каждого сотрудника. Например, если сотрудник загружен на 50%, то он учитывается в количестве 0,5.  

Чтобы перейти к просмотру и редактированию списка сотрудников в команде, наведите указатель на команду и нажмите кнопку ![](_assets/ico-edit.png).

## Указать необходимое количество сотрудников в контуре {#HC}

1. Найдите нужный контур в таблице.
1. Дважды нажмите внутри ячейки в столбце **HC**.
1. Укажите или отредактируйте необходимое количество сотрудников.

Количество сотрудников в зонтике пересчитается автоматически.

## Изменить информацию о сотруднике {#change}

1. Найдите нужный контур или зонтик в таблице.
1. Наведите указатель на команду и нажмите кнопку ![](_assets/ico-edit.png).
1. Выполните действие:
    
    #### Изменить участника команды {#change-member}
    
    Нажмите имя сотрудника, начните вводить новый логин, имя или фамилию и выберите из выпадающего списка.
    
    Чтобы удалить логин, нажмите кнопку ![](_assets/ico-del-cross.png).
    
    #### Указать или изменить профессию {#change-occupation}
    
    Нажмите прочерк или профессию рядом с именем сотрудника и выберите нужную из выпадающего списка.

    #### Изменить загрузку сотрудника {#change-load}

    Введите в поле новое значение.
    
1. Нажмите **Сохранить**.

## Изменить список сотрудников {#add-delete-worker}

1. Найдите нужный контур или зонтик в таблице.
1. Наведите указатель на команду и нажмите кнопку ![](_assets/ico-edit.png).
1. Выполните действие:
    
    #### Добавить сотрудника в команду {#add-member}
    
    1. Нажмите **Добавить участника**.
    1. Укажите логин сотрудника — начните вводить логин, фамилию или имя сотрудника и выберите из выпадающего списка.
    1. Выберите профессию сотрудника — нажмите прочерк и выберите профессию из выпадающего списка.
    1. Введите загрузку сотрудника в процентах.
    
    #### Удалить сотрудника из команды {#remove-member}

    Нажмите кнопку ![](_assets/delete.png) в строке сотрудника.
    
1. Нажмите **Сохранить**.

## Изменить список вакансий {#add-delete-vacancy}

1. Найдите нужный контур или зонтик в таблице.
1. Наведите указатель на команду и нажмите кнопку ![](_assets/ico-edit.png).
1. Выполните действие:
    
    #### Добавить вакансию {#add-vacancy}
    
    1. Нажмите **Добавить вакансию**.
    1. Укажите ID вакансии.
    1. Выберите нужную профессию для вакансии — нажмите прочерк и выберите профессию из выпадающего списка.
    
    #### Удалить вакансию {#delete-vacancy}

    Нажмите кнопку ![](_assets/delete.png) в строке вакансии.
    
1. Нажмите **Сохранить**.
