# Учет сотрудников в команде

Чтобы перейти в учет сотрудников в команде:

* из [табличного вида](hc-table-view.md) — нажмите **Перейти к учету людей** в столбце **Команда** нужной цели;
* из [карточки зонтика или контура](hc-goal-card.md) — нажмите **Перейти в учет сотрудников в команде** или **Перейти к учету людей**;
* из [карточки стрима](okr.md#view) (VS — {{ vs }}) — нажмите **Перейти в учет сотрудников в команде**.

Откроется таблица со списком всех сотрудников, работающих над выбранным контуром, зонтиком или стримом.

## Просмотреть список сотрудников или вакансий {#view}

В верхней части таблицы отображается название стрима, зонтика или контура и общее количество сотрудников, привязанных к его целям.

В строке каждого сотрудника указаны:

* общая загрузка в процентах;
* все цели, над которыми работает сотрудник;
* загрузка и профессия в каждой цели;
* Стафф-подразделение;
* основной зонт.

Вы можете выбирать варианты просмотра списка, используя фильтры в столбцах таблицы.

Чтобы отфильтровать список сотрудников по принадлежности к стриму или просмотреть только вакансии:

1. Нажмите ![](_assets/ico-filter-okr.png) **Сотрудник или вакансия**.
1. Выберите значение фильтра:
    
    * **Все** — в таблице отобразятся все сотрудники и вакансии, чья загрузка привязана к просматриваемому стриму.
    * **Только текущий VS** — в таблице отобразятся только те сотрудники, чья бюджетная позиция принадлежит просматриваемому стриму.
    * **Чужие VS** — в таблице отобразятся только те сотрудники, чья бюджетная позиция не принадлежит просматриваемому стриму, но их загрузка привязана к целям текущего стрима. В столбце **Сотрудник или вакансия** будет указан стрим сотрудника.
    * **Вакансии** — в таблице отобразятся только вакансии стрима.
    
Общее количество сотрудников в верхней части таблицы изменится с учетом выбранного фильтра.

## Изменить цели и загрузку сотрудника {#change}

1. В строке сотрудника наведите указатель на его цели и загрузку.
1. Нажмите кнопку ![](_assets/ico-edit.png).
1. Выполните действие:
    
    #### Изменить цель {#change-goal}
    
    1. В поле с названием цели нажмите кнопку ![](_assets/ico-del-cross.png), чтобы удалить текущую цель.
    1. Начните вводить название цели и выберите из выпадающего списка.
    
    #### Изменить загрузку {#change-load}

    В строке цели укажите новое значение загрузки. После сохранения изменений общая загрузка сотрудника пересчитается автоматически.

    #### Изменить профессию {#change-job}
    
    1. В строке цели нажмите профессию или прочерк, если профессия не указана.
    1. Выберите профессию из выпадающего списка.
    
    #### Добавить цель {#add-goal}
    
    1. Нажмите **Добавить цель**.
    1. Начните вводить название цели и выберите из выпадающего списка.
    1. Нажмите прочерк и выберите профессию из выпадающего списка.
    1. Укажите загрузку в процентах.
    
    #### Удалить цель {#delete-goal}

    В конце строки цели нажмите кнопку ![](_assets/ico-del-cross.png).
    
1. Нажмите **Сохранить**.

## Указать основной зонт сотрудника {#umbrella}

Основной зонт выбирается руководителем сотрудника для его оценки в процессе ревью. У каждого сотрудника может быть выбран только один основной зонт.

Чтобы указать или изменить основной зонт:

1. В строке сотрудника наведите указатель на основной зонт или на пустую ячейку в столбце **Основной зонт**, если зонт не указан.
1. Нажмите кнопку ![](_assets/ico-edit.png).
1. Нажмите кнопку ![](_assets/ico-del-cross.png), чтобы удалить указанный зонт.
1. Начните вводить название зонта и выберите нужный из выпадающего списка.
1. Нажмите **Сохранить**.

## Привязать вакансию к цели {#vacancy}

1. В строке вакансии нажмите кнопку ![](_assets/ico-edit.png).
1. Нажмите **Добавить цель**.
1. Начните вводить название цели и выберите из выпадающего списка.
1. Нажмите **Сохранить**.

{% note info %}

Вакансия может быть привязана только на 100% и только к одному контуру или зонту.

{% endnote %}

## Добавить профессию для стрима {#profession}

1. В верхней части таблицы нажмите кнопку ![](_assets/ico-columns.png).
1. Нажмите **Добавить профессию для VS**.
1. Укажите слаг (идентификатор) профессии и ее название на русском и английском языке.
1. Нажмите **Сохранить**.

{% note info %}

Профессии могут добавлять только руководители и менеджеры стрима и зонтов.

{% endnote %}

## Сохранить таблицу {#save}

В правом верхнем углу нажмите **Выгрузить людей**. Таблица сохранится на вашем компьютере в формате XLSX.
