# Управление сотрудниками

При реализации целей [Градиента](okr.md) вы можете управлять человеческими ресурсами:

* планировать, сколько людей необходимо для реализации целей (Objectives) и ключевых результатов (Key Results);
* корректировать загрузку сотрудников;
* видеть, сотрудники каких профессий работают над целью, и понимать, каких специалистов не хватает;
* следить за соотношением вакансий и сотрудников, которые уже работают над целью;
* определить, по какому зонтику следует оценивать сотрудника в процессе ревью.

Вы можете управлять человеческими ресурсами в разрезе бизнеса (OKR) и административных направлений (по [Стафф-структуре](https://staff.yandex-team.ru/departments/yandex)).

## Учет сотрудников при планировании целей {#planning}

Для учета сотрудников при планировании целей используется единица измерения численности сотрудников — HeadCount.

Виды HeadCount, которые можно запланировать в Целях:

* сотрудники Яндекса, которые работают над целью;
* вакансии, открытые для поиска специалистов определенных профессий;
* нераспределенный HeadCount — запланированный человеческий ресурс, для которого не определены сотрудник или вакансия.

## Учет сотрудников при реализации целей {#realization}

Для просмотра фактического состава команды и внесения изменений используйте один из способов (выбор способа зависит от действий, которые хотите совершить):

* [Табличный вид](hc-table-view.md)
    * Посмотреть запланированное и фактическое количество сотрудников.
    * Указать необходимое количество сотрудников в контуре.
    * Изменить информацию о сотруднике.
    * Посмотреть и изменить состав команды.
    
* [Вкладка **Команда** в карточке цели](hc-goal-card.md)
    * Посмотреть и изменить состав команды.
    * Изменить информацию о сотруднике.
    
* [Раздел **Учет сотрудников в команде**](hc-team-accounting.md)
    * Посмотреть и изменить цели, профессию и процент занятости сотрудника.
    * Редактировать вакансии.
    * Посмотреть, сколько сотрудников из других стримов работает над вашими целями.
    * Посмотреть основной зонтик сотрудника.
    
* [Раздел **Учет сотрудников в подразделении**](hc-division-accounting.md)
    * Проверить, у всех ли сотрудников подразделения есть цели.
    * Узнать, есть ли перегруженные или недогруженные сотрудники.
