# Стримы/активности мобильных приложений

## Что это?

Есть очередь в стартреке, которая хранит в себе список постоянных активностей, которые необходимы мобилкам и которые выполняют сотрудники.

{% note warning %}

Постоянная активность - это что-то, что нужно делать постоянно (не месяц, не квартал, не год). Может с некоторой периодичностью (раз в месяц), но на постоянной основе.

{% endnote %}

## Зачем это?

1. Для отслеживания активностей, которые есть. Если у кого-то появляется желание вести что-то и улучшать, то можно увидеть свободные активности.
2. Для уменьшения bus-factor. Во-первых, чтобы подхватить активности человека при увольнении или отпуске. Во-вторых, чтобы отследить, что активность трудно подхватить и работать над этим
3. Для снижения нагрузки. Если на человеке висит много активностей, то желательно передать какие-то, чтобы более эффективно выполнять несколько, а не много
4. В качестве точки входа работ по активности. К примеру к активности по ЦУМу крепятся тикеты и исполнитель понимает, что накапливаются проблемы в какой-то части и выделяет время на их решение

## Как это использовать?

### Борда

Есть [борда](https://st.yandex-team.ru/dashboard/46712)

На ней можно увидеть основную информацию, а также различного характера виджеты

### Критичность активности

Тикетам может выставляться приоритет:
1. Блокер - без исполнителя у этой активности мы будем разваливаться. Например менеджер поддержки и дежурств
2. Критичный - активность влияет на основополагающие процессы в работе
3. Обычный - активность позволяет жить хорошо, но не являетя остро необходимой в работе

### Напоминания

В очереди реализована система напоминаний об активностях

Для того, чтобы вам приходили напомниания об активности, нужно:
1. Добавить тег с частотой напоминаний
2. Поменять поле "Время проверки повторно"
Это поле инкрементируется каждый день и при достижении порога, соответствеющего тегу, обнуляется и отправляет письмо исполнителю.
Если вам нужно подстроить напоминание, то можете руками поменять поле.
Например, вам нужно, чтобы напоминание приходило каждые 3 месяца, а первое пришло через 1 месяц. Выставляете в поле 60, через 30 дней оно достигнет 90, обнулится и пришлёт письмо.

### Отдать активность

Если вы перезагружены и хотите отдать активность тому, кто сможет уделять больше времени и внимания ей, то можно поставить тег "готов_отдать". Тогда активность появится в соответствующем виджете.
А если вы хотите взять активность, то можно посмотреть на этот виджет.
