# Урок 15. Секреты

{% include [note-alert](../_includes/onboarding-alert.md) %}

**Секрет (Secret)** — это ключ к чувствительной информации (пароли, сертификаты, токены). Использование секретов — надежный способ хранить, передавать и использовать такую информацию, ведь она должна быть доступна строго ограниченному числу сотрудников. Например, в Нирване секреты позволяют графам создавать пулы в Толоке или ЯНГе от имени нужного аккаунта. С помощью секрета в граф передается значение [OAuth-токена](https://tech.yandex.ru/oauth/doc/dg/concepts/glossary-docpage/) для доступа к тому или иному внутреннему сервису.Все созданные тобой или доступные чужие секреты будут показываться в разделе `Secrets` бокового меню.

Для передачи значения секрета в Нирване используются опции с типом `Secret`. При этом для защиты информации в опции указывается не содержимое секрета, а его название, указанное при создании. Чтобы использовать секрет в графе, необходимо выдать доступ к нему тому пользователю, от имени которого запускается граф — не забудь об этом, если твои инстансы выполняются от имени технического пользователя (робота).

Подробнее о секретах можно прочитать [здесь](https://wiki.yandex-team.ru/passport/yav-usage/), а о работе с секретами в Нирване — [здесь](https://wiki.yandex-team.ru/nirvana/vodstvo/rabota-s-sekretami-v-nirvane/#obnovleniesekretamytoken).

![https://lead-assessors.s3.yandex.net/0bf133f7-a347-4fd1-af40-b4d3d85294cc](https://lead-assessors.s3.yandex.net/0bf133f7-a347-4fd1-af40-b4d3d85294cc)
