# Простые типы параметров

Простые типы не приводятся к другим типам. [Сложные типы](parameters-complex-ov.md), в свою очередь, могут быть приведены к простым.

Все простые типы параметров, а также их значения по умолчанию указаны в следующей таблице:

#|
|| Имя типа | Значение по умолчанию ||
|| Bool, Boolean | false ||
|| Double | 0 ||
|| Float | 0 ||
|| Long | 0 || 
|| LongLong, Long Long | 0 ||
|| String |	"" (пустая строка) ||
|| ULong, Unsigned Long | 0 ||
|| ULongLong, Unsigned Long Long | 0||
|#
Значение по умолчанию используется, если значение не задано явно, или его невозможно извлечь из объекта или структуры.

**Примеры использования**:

```
<param type="Long">777</param>
//методу передаётся целочисленная константа 777

<param type="String">my text</param>
//методу передаётся строка "my text"

<param type="String"/>
//методу передаётся пустая строка;

<param type="ULongLong"/>
//методу передаётся 0
```

### Узнайте больше {#learn-more}
* [Все типы параметров методов, вызываемых в XScript-блоках](../appendices/block-param-types.md)