# Общие сведения

XScript — это XML-язык для создания динамических веб-страниц и среда исполнения сервисов, разработанных с использованием этого языка. Среда исполнения XScript имеет средства доступа к серверам по протоколам CORBA и HTTP. Кроме того, в XScript входит набор расширений XSL, используемых в верстке.

XScript применяется в сервисах с массовой, миллионной аудиторией, работающих в режиме 24x7x365 и использующих верстку в технологии XML/XSL. XScript может работать в сервисах с кластерной структурой или в сервисе с единственным сервером. Кластерная структура подразумевает наличие front-end-серверов, на которых работают веб-сервер и XScript, и back-end-серверов, формирующими контент и отдающими его по CORBA и HTTP.

XML-язык XScript содержит набор элементов (тегов), которые добавляются в исходный код XML-страницы и интерпретируются при её обработке. Базовым элементом языка является блок - XML-элемент, в котором описывается вызов локального или удаленного метода. Результат работы метода помещается в код страницы на место блока.

Создание страницы на XScript состоит из трёх этапов:
- нахождение подходящих блоков или CORBA-компонентов и их методов. В случае отсутствия подходящих CORBA-компонентов или блоков, могут быть написаны новые;
- написание XML-файла веб-страницы, содержащей вызовы этих методов;
- разработка XSL-преобразования, формирующего окончательный внешний вид страницы.

Обычно работу на первых двух этапах выполняет программист, на последнем — разработчик интерфейсов.

{% note info %}

XScript непрерывно развивается: появляются новые возможности и ликвидируются устаревшие. Чтобы всегда быть в курсе последних изменений, читайте рассылки [XScript](https://ml.yandex-team.ru/lists/xscript) и [Verstka](https://ml.yandex-team.ru/lists/verstka/).

{% endnote %}

### Узнайте больше {#learn-more}
* [Обработка запроса](../concepts/xscript-functionality.md)
* [XML-файл на XScript](../concepts/xscript-file-ov.md)

## Страницы истории {#authors}

Первая версия XScript была написана в 2001 году [Василием Чекалкиным](http://staff.yandex.ru/bacek).

XScript версии 4 был разрабатывался Василием Чекалкиным совместно с [Олегом Оболенским](http://staff.yandex.ru/highpower) и применялся исключительно в Яндексе.

В 2006 году Олегом Оболенским была начата работа над XScript 5, который в 2007 году начал применяться в проектах Яндекса, а в 2008 был выпущен как Open Source продукт.

В настоящий момент разработкой XScript занимается команда под руководством [Алексея Пономарева](http://staff.yandex.ru/ponomarev).

