# Как загрузить страницу без XSL-преобразования

Для того чтобы загрузить страницу без XSL-преобразования, выполните следующие действия:

1. Определите, нужно ли отменить XSL-преобразование на все запросы пользователя на уровне XML-файла, или однократно и на уровне конкретного запроса.
	*  Если требуется отменить основное XSL-преобразование на уровне XML-файла, установите в исходном XML-файле атрибут `xslt-dont-apply="yes"` тега [\<xscript\>](../reference/xscript.md).

	* Если требуется отменить XSL-преобразование на уровне конкретного запроса, в браузере в URL запрашиваемой страницы необходимо указать номер порта `alternate-port` (страница без основного XSL-преобразования) или `noxslt-port` (страница и без основного, и без перблочного XSL-преобразования). Номера этих портов задаются в [файле настроек](../appendices/config.md) XScript.

	Например, если в качестве `alternate-port` задан порт 8080, получить страницу без основного XSL-преобразования можно по адресу

	```
	http://something.somewhere.yandex.ru:8080/
    ```

1. Загрузите страницу.
    

В результате выполнения описанных действий будет загружен XML-файл в том виде, в котором он находится после работы всех XScript-блоков без наложения основного XSL-преобразования, а в случае запроса к `noxslt-port` - без основного и без перблочного преобразования.

### Узнайте больше {#learn-more}
* [Основное XSL-преобразование](../concepts/per-block-transformation-ov.md)
* [Перблочное XSL-преобразование](../concepts/per-block-transformation-ov.md)