# Лендинги

### Что это такое

Лендинги - система конфигурирования и публикации посадочных страниц Сервисной модели, в которой страницы конфигурируются из готового набора блоков

### Зачем нужны

- Повысить конверсию в сервисный заказ за счёт контента, на каждом шаге создания заказа отвечающего на релевантные вопросы и работающего с актуальными болями пользователей.
- Быстро создавать и дополнять посадочные страницы для новых профессий, специальностей и услуг, которые мы подключаем к сервисной модели.
- Повысить позиции в поисковиках и привлечь больше органического трафика за счёт нового специфичного для конкретных категорий и услуг статичного контента.

### Как увидеть

- Лендинги показываются для категорий услуг Сервисной модели (СМ). Список таких категорий можно найти в [конфиге](https://a.yandex-team.ru/arcadia/ydo/rubricator/service_model_categories.json). Кроме того, на показ могут влиять эксперименты.
- Самый простой способом увидеть лендинг - перейти на страницу СМ-категории из каталога на главной странице Услуг или саджеста рубрикатора там же.

### Работа с лендингами

- Схема конфига
  - [Конфиг блока](block-config.md)
  - [Доступные блоки](available-blocks.md)
- Процесс конфигурирования
  - [Управление конфигами в админке](config-setting-admin.md)
  - [Проверка конфига](config-check.md)
- Техническая реализация
  - [Работа на фронте клиентского приложения Услуг](frontend.md)

### Макеты

- [Общие правила и блоки](https://www.figma.com/file/x9uL0bq9JQ87ILcqB3v6y0/%D0%A1%D0%BE%D0%B7%D0%B4%D0%B0%D0%BD%D0%B8%D0%B5-%D0%B7%D0%B0%D0%BA%D0%B0%D0%B7%D0%B0?node-id=1398%3A0)
- [Готовые блоки (старое)](https://www.figma.com/file/LCpK24ND8J4EcaKNVhZmDY/%D0%9A%D0%B0%D1%80%D0%BB-%D0%9C%D0%B0%D1%80%D0%BA%D1%81?node-id=2659%3A10085)

### Куда писать

Канал обсуждения лендингов в Slack'е [#landings](https://yndx-uslugi.slack.com/archives/C0293RC2DRU)

