# Статичные ручки

В нашем коде есть возможность создавать статичные ручки, для которых не будет выполняться поход
в наш бекенд, благодаря чему такие ручки отвечают быстро и не создают лишнюю нагрузку на бекенд.
Для статичной ручки будет отрабатывать фронтовый серверный код, благодаря чему ответы в статичной ручке можно кастомизировать.

{% note info %}

В статичные ручки можно передавать как GET, так и POST параметры, но для POST параметров не прописаны тайпинги

{% endnote %}

{% note warning %}

Возможна ситуация во время релиза, когда с верстки уходит запрос на машинку, на которой старая версия шаблонов.
Ести такое поведение неприемлемо, лучше выкатить одним релизом новую ручку, а следующим уже код на фронте, который будет обращаться к новой ручке.

{% endnote %}

Варианты использования статичных ручек:
* загрузка файлов с шаблонизацией, которые лежат в нашем коде ([пример](https://a.yandex-team.ru/arcadia/frontend/services/ydo/src/report-renderer/api-router.ts?rev=r9683915#L486))
* загрузка части данных, т.к. гонять весь объем данных накладно ([пример](https://a.yandex-team.ru/arcadia/frontend/services/ydo/src/report-renderer/api-router.ts?rev=r9683915#L679))
* загрузка статичной верстки ([пример](https://a.yandex-team.ru/arcadia/frontend/services/ydo/src/report-renderer/api-router.ts?rev=r9683915#L703))
* и множество других вариантов, для которых не нужен ответ бека

Какие данные доступны для статичных ручек:
* эксп флаги
* blackbox
* рубрики и фичи
* весь код адаптеров
